#ifndef GPU_H
#define GPU_H

// Param struct
typedef struct {
    HWND  *HWnd;
    UINT8 *SystemRam;
} GPU_Struct;

// Starting functions
int  GPU_Open(GPU_Struct *gpu);
void GPU_Close(void);

// I/O GPU ports
UINT32 GP0_Read(void);
UINT32 GP1_Read(void);
void   GP0_Write(UINT32 data);
void   GP1_Write(UINT32 code);

// Refresh function
void GPU_Update(void);

// Dma function
void GPU_DmaExec(UINT32 adr,UINT32 bcr,UINT32 chcr);

// ScreenShot
void GPU_ScreenShot(char *path);

// High level functions
int  GPU_Configure(void);
void GPU_About(void);

#endif
