#include <windows.h>
#include <stdio.h>
#include <memory.h>
#include <malloc.h>

#include "fpse.h"

HWND FPSE_hwnd;

static char fps_en=0;
char *scrpath = { "snaps\\" };

LRESULT APIENTRY WndFunc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
    HDC hdc;

    switch (msg) {
    case WM_KEYDOWN:
        switch(wParam) {
            case VK_ESCAPE:
                DestroyWindow(hwnd);
                break;
            case VK_F12:
                GPU_ScreenShot(scrpath);
                break;
            case VK_F11:
                fps_en ^= 1;
                break;
        }
        break;
    case WM_PAINT:
        GPU_Update();
        {
            PAINTSTRUCT ps;
            static int t0,t1,frame,fps;
            char szbuf[20];            

            hdc = BeginPaint(hwnd,&ps);

            if (fps_en) {
                if ((t1=GetTickCount()-t0)>1000) {
                    fps = 1000*frame/t1;
                    t0+=t1;
                    frame=0;
                }
                frame++;

                wsprintf(szbuf,"fps:%d",fps);
                TextOut(hdc,0,0,szbuf,strlen(szbuf));
            }
            EndPaint(hwnd,&ps);
        }
        break;
	case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return DefWindowProc(hwnd,msg,wParam,lParam);
    }
    return 0;
}

void win_init(void)
{
    static char szAppName[] = "FPSE Display";
    static char szClassName[] = "FPSE";
    WNDCLASS wndclass;

    HINSTANCE hInst = 0;

    wndclass.style = 0; //CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc = WndFunc;
    wndclass.cbClsExtra = 0;
    wndclass.cbWndExtra = 0;
    wndclass.hInstance = hInst;
    wndclass.hIcon = LoadIcon(NULL,IDI_APPLICATION);
    wndclass.hCursor = LoadCursor(NULL,IDC_ARROW);
    wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
    wndclass.lpszMenuName = NULL;
    wndclass.lpszClassName = szClassName;

    RegisterClass(&wndclass);

    FPSE_hwnd = CreateWindow(
		szClassName, //classname
		szAppName, //title
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		320,
		240,
		NULL, //parent
		NULL, //menu
		hInst,
		NULL);

    ShowWindow(FPSE_hwnd,SW_SHOW);
    UpdateWindow(FPSE_hwnd);
}

void win_update(void)
{
    MSG msg;

    InvalidateRect(FPSE_hwnd,NULL,FALSE);
    while (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
        if (msg.message==WM_QUIT) exit(msg.wParam);
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
}
